from Crypto.Cipher import AES
from base64 import b64decode
import sys

#Read the whole packet
with open(sys.argv[1], "rb") as f:
  data = f.read()
  

while len(data) > 0:
  #Format is:
  #
  #Len | IV | AES-256-CBC
  #
  #Repeated as necessary
  
  #Len is encoded as sequence of five wiehgted bytes. The rightmost (data[4]) has wieght 1 and each byte to the left of another
  #has weight 100 times the former.
  dlen = data[0] * 100000000 + data[1] * 1000000 + data[2] * 10000 + data[3] * 100 + data[4]
  
  #Remove the len
  data = data[5:]
  
  #Get only this chunk and remove it from data
  p = data[:dlen]
  data = data[dlen:]
  
  #Get the IV and the ciphertext
  iv = p[:16]
  enc = p[16:]
  cipher = AES.new(b64decode(sys.argv[2]), AES.MODE_CBC, iv=iv)
  
  #The first byte is skipped by the malware (it's a non printable char)
  print((cipher.decrypt(enc)[1:]).decode("utf-8"))
